diff --git a/drivers/tty/serial/8250/8250_port.c b/drivers/tty/serial/8250/8250_port.c
index b4c8388ea6fc..26393c483ce7 100644
--- a/drivers/tty/serial/8250/8250_port.c
+++ b/drivers/tty/serial/8250/8250_port.c
@@ -1510,6 +1510,9 @@ static void serial8250_stop_tx(struct uart_port *port)
 		serial_icr_write(up, UART_ACR, up->acr);
 	}
 	serial8250_rpm_put(up);
+
+	if (port->hw_stopped && (up->bugs & UART_BUG_NOMSI))
+		mod_timer(&up->timer, jiffies + 1);
 }
 
 static inline void __start_tx(struct uart_port *port)
@@ -1623,6 +1626,9 @@ static void serial8250_start_tx(struct uart_port *port)
 	/* Port locked to synchronize UART_IER access against the console. */
 	lockdep_assert_held_once(&port->lock);
 
+	if (up->bugs & UART_BUG_NOMSI)
+		del_timer(&up->timer);
+
 	if (!port->x_char && kfifo_is_empty(&port->state->port.xmit_fifo))
 		return;
 
@@ -1851,6 +1857,9 @@ unsigned int serial8250_modem_status(struct uart_8250_port *up)
 			uart_handle_cts_change(port, status & UART_MSR_CTS);
 
 		wake_up_interruptible(&port->state->port.delta_msr_wait);
+	} else if (up->bugs & UART_BUG_NOMSI &&	port->hw_stopped &&
+		   status & UART_MSR_CTS) {
+		uart_handle_cts_change(port, status & UART_MSR_CTS);
 	}
 
 	return status;
diff --git a/drivers/tty/serial/Kconfig b/drivers/tty/serial/Kconfig
index 1e92b16b6b95..ad212d32a8fc 100644
--- a/drivers/tty/serial/Kconfig
+++ b/drivers/tty/serial/Kconfig
@@ -1600,6 +1600,17 @@ config SERIAL_ESP32_ACM
 	  snippet may be used:
 	    earlycon=esp32s3acm,mmio32,0x60038000
 
+config SERIAL_RPI_FW
+	tristate "Raspberry Pi Firmware software UART support"
+	depends on RASPBERRYPI_FIRMWARE || COMPILE_TEST
+	select SERIAL_CORE
+	help
+	  This selects the Raspberry Pi firmware UART. This is a bit-bashed
+	  implementation running on the Raspbery Pi VPU core.
+	  This is not supported on Raspberry Pi 5 or newer platforms.
+
+	  If unsure, say N.
+
 endmenu
 
 config SERIAL_MCTRL_GPIO
diff --git a/drivers/tty/serial/Makefile b/drivers/tty/serial/Makefile
index 6ff74f0a9530..49b23cc3457f 100644
--- a/drivers/tty/serial/Makefile
+++ b/drivers/tty/serial/Makefile
@@ -71,6 +71,7 @@ obj-$(CONFIG_SERIAL_QCOM_GENI)		+= qcom_geni_serial.o
 obj-$(CONFIG_SERIAL_QE)			+= ucc_uart.o
 obj-$(CONFIG_SERIAL_RDA)		+= rda-uart.o
 obj-$(CONFIG_SERIAL_RP2)		+= rp2.o
+obj-$(CONFIG_SERIAL_RPI_FW) 		+= rpi-fw-uart.o
 obj-$(CONFIG_SERIAL_SA1100)		+= sa1100.o
 obj-$(CONFIG_SERIAL_SAMSUNG)		+= samsung_tty.o
 obj-$(CONFIG_SERIAL_SB1250_DUART)	+= sb1250-duart.o
diff --git a/drivers/tty/serial/amba-pl011.c b/drivers/tty/serial/amba-pl011.c
index 3713b23536dc..1e24bbc1f006 100644
--- a/drivers/tty/serial/amba-pl011.c
+++ b/drivers/tty/serial/amba-pl011.c
@@ -152,6 +152,20 @@ static const struct vendor_data vendor_sbsa = {
 	.fixed_options		= true,
 };
 
+static struct vendor_data vendor_arm_axi = {
+	.reg_offset		= pl011_std_offsets,
+	.ifls			= UART011_IFLS_RX4_8 | UART011_IFLS_TX4_8,
+	.fr_busy		= UART01x_FR_BUSY,
+	.fr_dsr			= UART01x_FR_DSR,
+	.fr_cts			= UART01x_FR_CTS,
+	.fr_ri			= UART011_FR_RI,
+	.oversampling		= false,
+	.dma_threshold		= false,
+	.cts_event_workaround	= false,
+	.always_enabled		= false,
+	.fixed_options		= false,
+};
+
 #ifdef CONFIG_ACPI_SPCR_TABLE
 static const struct vendor_data vendor_qdt_qdf2400_e44 = {
 	.reg_offset		= pl011_std_offsets,
@@ -451,6 +465,7 @@ static void pl011_dma_probe(struct uart_amba_port *uap)
 			.src_addr = uap->port.mapbase +
 				pl011_reg_to_offset(uap, REG_DR),
 			.src_addr_width = DMA_SLAVE_BUSWIDTH_1_BYTE,
+			.dst_addr_width = DMA_SLAVE_BUSWIDTH_1_BYTE,
 			.direction = DMA_DEV_TO_MEM,
 			.src_maxburst = uap->fifosize >> 2,
 			.device_fc = false,
@@ -470,6 +485,12 @@ static void pl011_dma_probe(struct uart_amba_port *uap)
 					 "RX DMA disabled - no residue processing\n");
 				return;
 			}
+			/*
+			 * DMA controllers with smaller burst capabilities than 1/4
+			 * the FIFO depth will leave more bytes than expected in the
+			 * RX FIFO if mismatched.
+			 */
+			rx_conf.src_maxburst = min(caps.max_burst, rx_conf.src_maxburst);
 		}
 		dmaengine_slave_config(chan, &rx_conf);
 		uap->dmarx.chan = chan;
@@ -1433,6 +1454,7 @@ static bool pl011_tx_char(struct uart_amba_port *uap, unsigned char c,
 		return false; /* unable to transmit character */
 
 	pl011_write(c, uap, REG_DR);
+	mb();
 	uap->port.icount.tx++;
 
 	return true;
@@ -1465,6 +1487,10 @@ static bool pl011_tx_chars(struct uart_amba_port *uap, bool from_irq)
 		if (likely(from_irq) && count-- == 0)
 			break;
 
+		if (likely(from_irq) && count == 0 &&
+		    pl011_read(uap, REG_FR) & UART01x_FR_TXFF)
+			break;
+
 		if (!kfifo_peek(&tport->xmit_fifo, &c))
 			break;
 
@@ -2782,6 +2808,11 @@ static int pl011_probe(struct amba_device *dev, const struct amba_id *id)
 	if (IS_ERR(uap->clk))
 		return PTR_ERR(uap->clk);
 
+	if (of_property_read_bool(dev->dev.of_node, "cts-event-workaround")) {
+	    vendor->cts_event_workaround = true;
+	    dev_info(&dev->dev, "cts_event_workaround enabled\n");
+	}
+
 	uap->reg_offset = vendor->reg_offset;
 	uap->vendor = vendor;
 	uap->fifosize = vendor->get_fifosize(dev);
@@ -2954,6 +2985,87 @@ static struct platform_driver arm_sbsa_uart_platform_driver = {
 	},
 };
 
+static int pl011_axi_probe(struct platform_device *pdev)
+{
+	struct uart_amba_port *uap;
+	struct vendor_data *vendor =  &vendor_arm_axi;
+	struct resource *r;
+	unsigned int periphid;
+	int portnr, ret, irq;
+
+	portnr = pl011_find_free_port();
+	if (portnr < 0)
+		return portnr;
+
+	uap = devm_kzalloc(&pdev->dev, sizeof(struct uart_amba_port),
+			   GFP_KERNEL);
+	if (!uap)
+		return -ENOMEM;
+
+	uap->clk = devm_clk_get(&pdev->dev, NULL);
+	if (IS_ERR(uap->clk))
+		return PTR_ERR(uap->clk);
+
+	if (of_property_read_bool(pdev->dev.of_node, "cts-event-workaround")) {
+		vendor->cts_event_workaround = true;
+		dev_info(&pdev->dev, "cts_event_workaround enabled\n");
+	}
+
+	irq = platform_get_irq(pdev, 0);
+	if (irq < 0)
+		return irq;
+
+	periphid = 0x00241011; /* A safe default */
+	of_property_read_u32(pdev->dev.of_node, "arm,primecell-periphid",
+			     &periphid);
+
+	uap->reg_offset = vendor->reg_offset;
+	uap->vendor = vendor;
+	uap->fifosize = (AMBA_REV_BITS(periphid) < 3) ? 16 : 32;
+	uap->port.iotype = vendor->access_32b ? UPIO_MEM32 : UPIO_MEM;
+	uap->port.irq = irq;
+	uap->port.ops = &amba_pl011_pops;
+	uap->port.rs485_config = pl011_rs485_config;
+	uap->port.rs485_supported = pl011_rs485_supported;
+
+	snprintf(uap->type, sizeof(uap->type), "PL011 AXI");
+
+	r = platform_get_resource(pdev, IORESOURCE_MEM, 0);
+
+	ret = pl011_setup_port(&pdev->dev, uap, r, portnr);
+	if (ret)
+		return ret;
+
+	platform_set_drvdata(pdev, uap);
+
+	return pl011_register_port(uap);
+}
+
+static void pl011_axi_remove(struct platform_device *pdev)
+{
+	struct uart_amba_port *uap = platform_get_drvdata(pdev);
+
+	uart_remove_one_port(&amba_reg, &uap->port);
+	pl011_unregister_port(uap);
+}
+
+static const struct of_device_id pl011_axi_of_match[] = {
+	{ .compatible = "arm,pl011-axi" },
+	{},
+};
+MODULE_DEVICE_TABLE(of, pl011_axi_of_match);
+
+static struct platform_driver pl011_axi_platform_driver = {
+	.probe		= pl011_axi_probe,
+	.remove		= pl011_axi_remove,
+	.driver	= {
+		.name	= "pl011-axi",
+		.pm	= &pl011_dev_pm_ops,
+		.of_match_table = of_match_ptr(pl011_axi_of_match),
+		.suppress_bind_attrs = IS_BUILTIN(CONFIG_SERIAL_AMBA_PL011),
+	},
+};
+
 static const struct amba_id pl011_ids[] = {
 	{
 		.id	= 0x00041011,
@@ -2987,12 +3099,15 @@ static int __init pl011_init(void)
 
 	if (platform_driver_register(&arm_sbsa_uart_platform_driver))
 		pr_warn("could not register SBSA UART platform driver\n");
+	if (platform_driver_register(&pl011_axi_platform_driver))
+		pr_warn("could not register PL011 AXI platform driver\n");
 	return amba_driver_register(&pl011_driver);
 }
 
 static void __exit pl011_exit(void)
 {
 	platform_driver_unregister(&arm_sbsa_uart_platform_driver);
+	platform_driver_unregister(&pl011_axi_platform_driver);
 	amba_driver_unregister(&pl011_driver);
 }
 
diff --git a/drivers/tty/serial/rpi-fw-uart.c b/drivers/tty/serial/rpi-fw-uart.c
new file mode 100644
index 000000000000..b6d3b68927f4
--- /dev/null
+++ b/drivers/tty/serial/rpi-fw-uart.c
@@ -0,0 +1,562 @@
+// SPDX-License-Identifier: GPL-2.0
+/*
+ * Copyright (c) 2024, Raspberry Pi Ltd.  All rights reserved.
+ */
+
+#include <linux/console.h>
+#include <linux/module.h>
+#include <linux/of.h>
+#include <linux/gpio/consumer.h>
+#include <linux/platform_device.h>
+#include <linux/serial.h>
+#include <linux/serial_core.h>
+#include <linux/slab.h>
+#include <linux/tty.h>
+#include <linux/tty_flip.h>
+#include <soc/bcm2835/raspberrypi-firmware.h>
+#include <linux/dma-mapping.h>
+
+#define RPI_FW_UART_RX_FIFO_RD	0xb0
+#define RPI_FW_UART_RX_FIFO_WR	0xb4
+#define RPI_FW_UART_TX_FIFO_RD	0xb8
+#define RPI_FW_UART_TX_FIFO_WR	0xbc
+
+#define RPI_FW_UART_FIFO_SIZE		32
+#define RPI_FW_UART_FIFO_SIZE_MASK	(RPI_FW_UART_FIFO_SIZE - 1)
+
+#define RPI_FW_UART_MIN_VERSION	3
+
+struct rpi_fw_uart_params {
+	u32 start;
+	u32 baud;
+	u32 data_bits;
+	u32 stop_bits;
+	u32 gpio_rx;
+	u32 gpio_tx;
+	u32 flags;
+	u32 fifosize;
+	u32 rx_buffer;
+	u32 tx_buffer;
+	u32 version;
+	u32 fifo_reg_base;
+};
+
+struct rpi_fw_uart {
+	struct uart_driver	driver;
+	struct uart_port	port;
+	struct rpi_firmware	*firmware;
+	struct gpio_desc	*rx_gpiod;
+	struct gpio_desc	*tx_gpiod;
+	unsigned int		rx_gpio;
+	unsigned int		tx_gpio;
+	unsigned int		baud;
+	unsigned int		data_bits;
+	unsigned int		stop_bits;
+	unsigned char __iomem	*base;
+	size_t			dma_buffer_size;
+
+	struct hrtimer		trigger_start_rx;
+	ktime_t			rx_poll_delay;
+	void			*rx_buffer;
+	dma_addr_t		rx_buffer_dma_addr;
+	int			rx_stop;
+
+	void			*tx_buffer;
+	dma_addr_t		tx_buffer_dma_addr;
+};
+
+static unsigned int rpi_fw_uart_tx_is_full(struct uart_port *port)
+{
+	struct rpi_fw_uart *rfu = container_of(port, struct rpi_fw_uart, port);
+	u32 rd, wr;
+
+	rd = readl(rfu->base + RPI_FW_UART_TX_FIFO_RD);
+	wr = readl(rfu->base + RPI_FW_UART_TX_FIFO_WR);
+	return ((wr + 1) & RPI_FW_UART_FIFO_SIZE_MASK) == rd;
+}
+
+static unsigned int rpi_fw_uart_tx_is_empty(struct uart_port *port)
+{
+	struct rpi_fw_uart *rfu = container_of(port, struct rpi_fw_uart, port);
+	u32 rd, wr;
+
+	if (!rfu->tx_buffer)
+		return 1;
+
+	rd = readl(rfu->base + RPI_FW_UART_TX_FIFO_RD);
+	wr = readl(rfu->base + RPI_FW_UART_TX_FIFO_WR);
+
+	return rd == wr;
+}
+
+static unsigned int rpi_fw_uart_rx_is_empty(struct uart_port *port)
+{
+	struct rpi_fw_uart *rfu = container_of(port, struct rpi_fw_uart, port);
+	u32 rd, wr;
+
+	if (!rfu->rx_buffer)
+		return 1;
+
+	rd = readl(rfu->base + RPI_FW_UART_RX_FIFO_RD);
+	wr = readl(rfu->base + RPI_FW_UART_RX_FIFO_WR);
+
+	return rd == wr;
+}
+
+static unsigned int rpi_fw_uart_tx_empty(struct uart_port *port)
+{
+	return rpi_fw_uart_tx_is_empty(port) ? TIOCSER_TEMT : 0;
+}
+
+static void rpi_fw_uart_set_mctrl(struct uart_port *port, unsigned int mctrl)
+{
+	/*
+	 * No hardware flow control, firmware automatically configures
+	 * TX to output high and RX to input low.
+	 */
+	dev_dbg(port->dev, "%s mctrl %u\n", __func__, mctrl);
+}
+
+static unsigned int rpi_fw_uart_get_mctrl(struct uart_port *port)
+{
+	/* No hardware flow control */
+	return TIOCM_CTS;
+}
+
+static void rpi_fw_uart_stop(struct uart_port *port)
+{
+	struct rpi_fw_uart_params msg = {.start = 0};
+	struct rpi_fw_uart *rfu = container_of(port, struct rpi_fw_uart, port);
+
+	hrtimer_cancel(&rfu->trigger_start_rx);
+
+	if (rpi_firmware_property(rfu->firmware,
+				RPI_FIRMWARE_SET_SW_UART,
+				&msg, sizeof(msg)))
+		dev_warn(port->dev,
+			 "Failed to shutdown rpi-fw uart. Firmware not configured?");
+}
+
+static void rpi_fw_uart_stop_tx(struct uart_port *port)
+{
+	/* No supported by the current firmware APIs. */
+}
+
+static void rpi_fw_uart_stop_rx(struct uart_port *port)
+{
+	struct rpi_fw_uart *rfu = container_of(port, struct rpi_fw_uart, port);
+
+	rfu->rx_stop = 1;
+}
+
+static unsigned int rpi_fw_write(struct uart_port *port, const char *s,
+				unsigned int count)
+{
+	struct rpi_fw_uart *rfu = container_of(port, struct rpi_fw_uart, port);
+	u8 *out = rfu->tx_buffer;
+	unsigned int consumed = 0;
+
+	while (consumed < count && !rpi_fw_uart_tx_is_full(port)) {
+		u32 wp = readl(rfu->base + RPI_FW_UART_TX_FIFO_WR)
+			& RPI_FW_UART_FIFO_SIZE_MASK;
+		out[wp] = s[consumed++];
+		wp = (wp + 1) & RPI_FW_UART_FIFO_SIZE_MASK;
+		writel(wp, rfu->base + RPI_FW_UART_TX_FIFO_WR);
+	}
+	return consumed;
+}
+
+/* Called with port.lock taken */
+static void rpi_fw_uart_start_tx(struct uart_port *port)
+{
+	struct tty_port *tport = &port->state->port;
+
+	for (;;) {
+		unsigned int consumed;
+		unsigned char *tail;
+		unsigned int count;
+
+		count = kfifo_out_linear_ptr(&tport->xmit_fifo, &tail, port->fifosize);
+		if (!count)
+			break;
+
+		consumed = rpi_fw_write(port, tail, count);
+		uart_xmit_advance(port, consumed);
+	}
+	uart_write_wakeup(port);
+}
+
+/* Called with port.lock taken */
+static void rpi_fw_uart_start_rx(struct uart_port *port)
+{
+	struct tty_port *tty_port = &port->state->port;
+	struct rpi_fw_uart *rfu = container_of(port, struct rpi_fw_uart, port);
+	int count = 0;
+
+	/*
+	 * RX is polled, read up to a full buffer of data before trying again
+	 * so that this can be interrupted if the firmware is filling the
+	 * buffer too fast
+	 */
+	while (!rpi_fw_uart_rx_is_empty(port) && count < port->fifosize) {
+		const u8 *in = rfu->rx_buffer;
+		u32 rp = readl(rfu->base + RPI_FW_UART_RX_FIFO_RD)
+			& RPI_FW_UART_FIFO_SIZE_MASK;
+
+		tty_insert_flip_char(tty_port, in[rp], TTY_NORMAL);
+		rp = (rp + 1) & RPI_FW_UART_FIFO_SIZE_MASK;
+		writel(rp, rfu->base + RPI_FW_UART_RX_FIFO_RD);
+		count++;
+	}
+	if (count)
+		tty_flip_buffer_push(tty_port);
+}
+
+static enum hrtimer_restart rpi_fw_uart_trigger_rx(struct hrtimer *t)
+{
+	unsigned long flags;
+	struct rpi_fw_uart *rfu = container_of(t, struct rpi_fw_uart,
+					      trigger_start_rx);
+
+	spin_lock_irqsave(&rfu->port.lock, flags);
+	if (rfu->rx_stop) {
+		spin_unlock_irqrestore(&rfu->port.lock, flags);
+		return HRTIMER_NORESTART;
+	}
+
+	rpi_fw_uart_start_rx(&rfu->port);
+	spin_unlock_irqrestore(&rfu->port.lock, flags);
+	hrtimer_forward_now(t, rfu->rx_poll_delay);
+	return HRTIMER_RESTART;
+}
+
+static void rpi_fw_uart_break_ctl(struct uart_port *port, int ctl)
+{
+	dev_dbg(port->dev, "%s ctl %d\n", __func__, ctl);
+}
+
+static int rpi_fw_uart_configure(struct uart_port *port)
+{
+	struct rpi_fw_uart *rfu = container_of(port, struct rpi_fw_uart, port);
+	struct rpi_fw_uart_params msg;
+	unsigned long flags;
+	int rc;
+
+	rpi_fw_uart_stop(port);
+
+	memset(&msg, 0, sizeof(msg));
+	msg.start = 1;
+	msg.gpio_rx = rfu->rx_gpio;
+	msg.gpio_tx = rfu->tx_gpio;
+	msg.data_bits = rfu->data_bits;
+	msg.stop_bits = rfu->stop_bits;
+	msg.baud = rfu->baud;
+	msg.fifosize = RPI_FW_UART_FIFO_SIZE;
+	msg.rx_buffer = (u32) rfu->rx_buffer_dma_addr;
+	msg.tx_buffer = (u32) rfu->tx_buffer_dma_addr;
+
+	rfu->rx_poll_delay = ms_to_ktime(50);
+
+	/*
+	 * Reconfigures the firmware UART with the new settings. On the first
+	 * call retrieve the addresses of the FIFO buffers. The buffers are
+	 * allocated at startup and are not de-allocated.
+	 * NB rpi_firmware_property can block
+	 */
+	rc = rpi_firmware_property(rfu->firmware,
+				RPI_FIRMWARE_SET_SW_UART,
+				&msg, sizeof(msg));
+	if (rc)
+		goto fail;
+
+	rc = rpi_firmware_property(rfu->firmware,
+			RPI_FIRMWARE_GET_SW_UART,
+			&msg, sizeof(msg));
+	if (rc)
+		goto fail;
+
+	dev_dbg(port->dev, "version %08x, reg addr %x\n", msg.version,
+		msg.fifo_reg_base);
+
+	dev_dbg(port->dev, "started %d baud %u data %u stop %u rx %u tx %u flags %u fifosize %u\n",
+		msg.start, msg.baud, msg.data_bits, msg.stop_bits,
+		msg.gpio_rx, msg.gpio_tx, msg.flags, msg.fifosize);
+
+	if (msg.fifosize != port->fifosize) {
+		dev_err(port->dev, "Expected fifo size %u actual %u",
+				port->fifosize, msg.fifosize);
+		rc = -EINVAL;
+		goto fail;
+	}
+
+	if (!msg.start) {
+		dev_err(port->dev, "Firmware service not running\n");
+		rc = -EINVAL;
+	}
+
+	spin_lock_irqsave(&rfu->port.lock, flags);
+	rfu->rx_stop = 0;
+	hrtimer_start(&rfu->trigger_start_rx,
+		      rfu->rx_poll_delay, HRTIMER_MODE_REL);
+	spin_unlock_irqrestore(&rfu->port.lock, flags);
+	return 0;
+fail:
+	dev_err(port->dev, "Failed to configure rpi-fw uart. Firmware not configured?");
+	return rc;
+}
+
+static void rpi_fw_uart_free_buffers(struct uart_port *port)
+{
+	struct rpi_fw_uart *rfu = container_of(port, struct rpi_fw_uart, port);
+
+	if (rfu->rx_buffer)
+		dma_free_coherent(port->dev, rfu->dma_buffer_size,
+				rfu->rx_buffer, GFP_ATOMIC);
+
+	if (rfu->tx_buffer)
+		dma_free_coherent(port->dev, rfu->dma_buffer_size,
+				rfu->tx_buffer, GFP_ATOMIC);
+
+	rfu->rx_buffer = NULL;
+	rfu->tx_buffer = NULL;
+	rfu->rx_buffer_dma_addr = 0;
+	rfu->tx_buffer_dma_addr = 0;
+}
+
+static int rpi_fw_uart_alloc_buffers(struct uart_port *port)
+{
+	struct rpi_fw_uart *rfu = container_of(port, struct rpi_fw_uart, port);
+
+	if (rfu->tx_buffer)
+		return 0;
+
+	rfu->dma_buffer_size = PAGE_ALIGN(RPI_FW_UART_FIFO_SIZE);
+
+	rfu->rx_buffer = dma_alloc_coherent(port->dev, rfu->dma_buffer_size,
+		&rfu->rx_buffer_dma_addr, GFP_ATOMIC);
+
+	if (!rfu->rx_buffer)
+		goto alloc_fail;
+
+	rfu->tx_buffer = dma_alloc_coherent(port->dev, rfu->dma_buffer_size,
+		&rfu->tx_buffer_dma_addr, GFP_ATOMIC);
+
+	if (!rfu->tx_buffer)
+		goto alloc_fail;
+
+	dev_dbg(port->dev, "alloc-buffers %p %x %p %x\n",
+		rfu->rx_buffer, (u32) rfu->rx_buffer_dma_addr,
+		rfu->tx_buffer, (u32) rfu->tx_buffer_dma_addr);
+	return 0;
+
+alloc_fail:
+	dev_err(port->dev, "%s uart buffer allocation failed\n", __func__);
+	rpi_fw_uart_free_buffers(port);
+	return -ENOMEM;
+}
+
+static int rpi_fw_uart_startup(struct uart_port *port)
+{
+	int rc;
+
+	rc = rpi_fw_uart_alloc_buffers(port);
+	if (rc)
+		dev_err(port->dev, "Failed to start\n");
+	return rc;
+}
+
+static void rpi_fw_uart_shutdown(struct uart_port *port)
+{
+	rpi_fw_uart_stop(port);
+	rpi_fw_uart_free_buffers(port);
+}
+
+static void rpi_fw_uart_set_termios(struct uart_port *port,
+				       struct ktermios *new,
+				       const struct ktermios *old)
+{
+	struct rpi_fw_uart *rfu =
+		container_of(port, struct rpi_fw_uart, port);
+	rfu->baud = uart_get_baud_rate(port, new, old, 50, 115200);
+	rfu->stop_bits = (new->c_cflag & CSTOPB) ? 2 : 1;
+
+	rpi_fw_uart_configure(port);
+}
+
+static const struct uart_ops rpi_fw_uart_ops = {
+	.tx_empty = rpi_fw_uart_tx_empty,
+	.set_mctrl = rpi_fw_uart_set_mctrl,
+	.get_mctrl = rpi_fw_uart_get_mctrl,
+	.stop_rx = rpi_fw_uart_stop_rx,
+	.stop_tx = rpi_fw_uart_stop_tx,
+	.start_tx = rpi_fw_uart_start_tx,
+	.break_ctl = rpi_fw_uart_break_ctl,
+	.startup = rpi_fw_uart_startup,
+	.shutdown = rpi_fw_uart_shutdown,
+	.set_termios = rpi_fw_uart_set_termios,
+};
+
+static int rpi_fw_uart_get_gpio_offset(struct device *dev, const char *name)
+{
+	struct of_phandle_args of_args = { 0 };
+	bool is_bcm28xx;
+
+	/* This really shouldn't fail, given that we have a gpiod */
+	if (of_parse_phandle_with_args(dev->of_node, name, "#gpio-cells", 0, &of_args))
+		return dev_err_probe(dev, -EINVAL, "can't find gpio declaration\n");
+
+	is_bcm28xx = of_device_is_compatible(of_args.np, "brcm,bcm2835-gpio") ||
+		     of_device_is_compatible(of_args.np, "brcm,bcm2711-gpio");
+	of_node_put(of_args.np);
+	if (!is_bcm28xx || of_args.args_count != 2)
+		return dev_err_probe(dev, -EINVAL, "not a BCM28xx gpio\n");
+
+	return of_args.args[0];
+}
+
+static int rpi_fw_uart_probe(struct platform_device *pdev)
+{
+	struct device_node *firmware_node;
+	struct device *dev = &pdev->dev;
+	struct rpi_firmware *firmware;
+	struct uart_port *port;
+	struct rpi_fw_uart *rfu;
+	struct rpi_fw_uart_params msg;
+	int version_major;
+	int err;
+
+	dev_dbg(dev, "%s of_node %p\n", __func__, dev->of_node);
+
+	/*
+	 * We can be probed either through the an old-fashioned
+	 * platform device registration or through a DT node that is a
+	 * child of the firmware node. Handle both cases.
+	 */
+	if (dev->of_node)
+		firmware_node = of_parse_phandle(dev->of_node, "firmware", 0);
+	else
+		firmware_node = of_find_compatible_node(NULL, NULL,
+				"raspberrypi,bcm2835-firmware");
+	if (!firmware_node) {
+		dev_err(dev, "Missing firmware node\n");
+		return -ENOENT;
+	}
+
+	firmware = devm_rpi_firmware_get(dev, firmware_node);
+	of_node_put(firmware_node);
+	if (!firmware)
+		return -EPROBE_DEFER;
+
+	rfu = devm_kzalloc(dev, sizeof(*rfu), GFP_KERNEL);
+	if (!rfu)
+		return -ENOMEM;
+
+	rfu->firmware = firmware;
+
+	err = rpi_firmware_property(rfu->firmware, RPI_FIRMWARE_GET_SW_UART,
+			&msg, sizeof(msg));
+	if (err) {
+		dev_err(dev, "VC firmware does not support rpi-fw-uart\n");
+		return err;
+	}
+
+	version_major = msg.version >> 16;
+	if (msg.version < RPI_FW_UART_MIN_VERSION) {
+		dev_err(dev, "rpi-fw-uart fw version %d is too old min version %d\n",
+				version_major, RPI_FW_UART_MIN_VERSION);
+		return -EINVAL;
+	}
+
+	rfu->rx_gpiod = devm_gpiod_get(dev, "rx", GPIOD_IN);
+	if (IS_ERR(rfu->rx_gpiod))
+		return PTR_ERR(rfu->rx_gpiod);
+
+	rfu->tx_gpiod = devm_gpiod_get(dev, "tx", GPIOD_OUT_HIGH);
+	if (IS_ERR(rfu->tx_gpiod))
+		return PTR_ERR(rfu->tx_gpiod);
+
+	rfu->rx_gpio = rpi_fw_uart_get_gpio_offset(dev, "rx-gpios");
+	if (rfu->rx_gpio < 0)
+		return rfu->rx_gpio;
+	rfu->tx_gpio = rpi_fw_uart_get_gpio_offset(dev, "tx-gpios");
+	if (rfu->tx_gpio < 0)
+		return rfu->tx_gpio;
+
+	rfu->base = devm_platform_ioremap_resource(pdev, 0);
+	if (IS_ERR(rfu->base))
+		return PTR_ERR(rfu->base);
+
+	/* setup the driver */
+	rfu->driver.owner = THIS_MODULE;
+	rfu->driver.driver_name = "ttyRFU";
+	rfu->driver.dev_name = "ttyRFU";
+	rfu->driver.nr = 1;
+	rfu->data_bits = 8;
+
+	/* RX is polled */
+	hrtimer_init(&rfu->trigger_start_rx, CLOCK_MONOTONIC, HRTIMER_MODE_REL);
+	rfu->trigger_start_rx.function = rpi_fw_uart_trigger_rx;
+
+	err = uart_register_driver(&rfu->driver);
+	if (err) {
+		dev_err(dev, "failed to register UART driver: %d\n",
+			err);
+		return err;
+	}
+
+	/* setup the port */
+	port = &rfu->port;
+	spin_lock_init(&port->lock);
+	port->dev = &pdev->dev;
+	port->type = PORT_RPI_FW;
+	port->ops = &rpi_fw_uart_ops;
+	port->fifosize = RPI_FW_UART_FIFO_SIZE;
+	port->iotype = UPIO_MEM;
+	port->flags = UPF_BOOT_AUTOCONF;
+	port->private_data = rfu;
+
+	err = uart_add_one_port(&rfu->driver, port);
+	if (err) {
+		dev_err(dev, "failed to add UART port: %d\n", err);
+		goto unregister_uart;
+	}
+	platform_set_drvdata(pdev, rfu);
+
+	dev_info(dev, "version %d.%d gpios tx %u rx %u\n",
+			msg.version >> 16, msg.version & 0xffff,
+			rfu->tx_gpio, rfu->rx_gpio);
+	return 0;
+
+unregister_uart:
+	uart_unregister_driver(&rfu->driver);
+
+	return err;
+}
+
+static void rpi_fw_uart_remove(struct platform_device *pdev)
+{
+	struct rpi_fw_uart *rfu = platform_get_drvdata(pdev);
+
+	uart_remove_one_port(&rfu->driver, &rfu->port);
+	uart_unregister_driver(&rfu->driver);
+}
+
+static const struct of_device_id rpi_fw_match[] = {
+	{ .compatible = "raspberrypi,firmware-uart" },
+	{ }
+};
+MODULE_DEVICE_TABLE(of, rpi_fw_match);
+
+static struct platform_driver rpi_fw_driver = {
+	.driver = {
+		.name = "rpi_fw-uart",
+		.of_match_table = rpi_fw_match,
+	},
+	.probe = rpi_fw_uart_probe,
+	.remove = rpi_fw_uart_remove,
+};
+module_platform_driver(rpi_fw_driver);
+
+MODULE_AUTHOR("Tim Gover <tim.gover@rasberrypi.com>");
+MODULE_LICENSE("GPL");
+MODULE_DESCRIPTION("Raspberry Pi Firmware Software UART driver");
diff --git a/drivers/tty/serial/sc16is7xx.c b/drivers/tty/serial/sc16is7xx.c
index 8ed8ee58e318..3aab1b728970 100644
--- a/drivers/tty/serial/sc16is7xx.c
+++ b/drivers/tty/serial/sc16is7xx.c
@@ -814,6 +814,8 @@ static bool sc16is7xx_port_irq(struct sc16is7xx_port *s, int portno)
 
 		if (rxlen)
 			sc16is7xx_handle_rx(port, rxlen, iir);
+		else
+			rc = false;
 		break;
 		/* CTSRTS interrupt comes only when CTS goes inactive */
 	case SC16IS7XX_IIR_CTSRTS_SRC:
@@ -1189,6 +1191,9 @@ static int sc16is7xx_startup(struct uart_port *port)
 	      SC16IS7XX_IER_MSI_BIT;
 	sc16is7xx_port_write(port, SC16IS7XX_IER_REG, val);
 
+	/* Initialize the Modem Control signals to current status */
+	one->old_mctrl = sc16is7xx_get_hwmctrl(port);
+
 	/* Enable modem status polling */
 	uart_port_lock_irqsave(port, &flags);
 	sc16is7xx_enable_ms(port);
@@ -1456,7 +1461,7 @@ static int sc16is7xx_setup_mctrl_ports(struct sc16is7xx_port *s,
 }
 
 static const struct serial_rs485 sc16is7xx_rs485_supported = {
-	.flags = SER_RS485_ENABLED | SER_RS485_RTS_AFTER_SEND,
+	.flags = SER_RS485_ENABLED | SER_RS485_RTS_ON_SEND | SER_RS485_RTS_AFTER_SEND,
 	.delay_rts_before_send = 1,
 	.delay_rts_after_send = 1,	/* Not supported but keep returning -EINVAL */
 };
diff --git a/drivers/usb/Makefile b/drivers/usb/Makefile
index 949eca0adebe..80af388baede 100644
--- a/drivers/usb/Makefile
+++ b/drivers/usb/Makefile
@@ -9,6 +9,7 @@ obj-$(CONFIG_USB_COMMON)	+= common/
 obj-$(CONFIG_USB)		+= core/
 obj-$(CONFIG_USB_SUPPORT)	+= phy/
 
+obj-$(CONFIG_USB_DWCOTG)	+= host/
 obj-$(CONFIG_USB_DWC3)		+= dwc3/
 obj-$(CONFIG_USB_DWC2)		+= dwc2/
 obj-$(CONFIG_USB_ISP1760)	+= isp1760/
diff --git a/drivers/usb/core/generic.c b/drivers/usb/core/generic.c
index b134bff5c3fe..f2d342d80bc0 100644
--- a/drivers/usb/core/generic.c
+++ b/drivers/usb/core/generic.c
@@ -206,6 +206,7 @@ int usb_choose_configuration(struct usb_device *udev)
 		dev_warn(&udev->dev,
 			"no configuration chosen from %d choice%s\n",
 			num_configs, plural(num_configs));
+		dev_warn(&udev->dev, "No support over %dmA\n", udev->bus_mA);
 	}
 	return i;
 }
diff --git a/drivers/usb/core/hcd.c b/drivers/usb/core/hcd.c
index bc795257696e..0a839e8fc6f1 100644
--- a/drivers/usb/core/hcd.c
+++ b/drivers/usb/core/hcd.c
@@ -1951,6 +1951,16 @@ int usb_hcd_alloc_bandwidth(struct usb_device *udev,
 	return ret;
 }
 
+void usb_hcd_fixup_endpoint(struct usb_device *udev,
+			    struct usb_host_endpoint *ep, int interval)
+{
+	struct usb_hcd *hcd;
+
+	hcd = bus_to_hcd(udev->bus);
+	if (hcd->driver->fixup_endpoint)
+		hcd->driver->fixup_endpoint(hcd, udev, ep, interval);
+}
+
 /* Disables the endpoint: synchronizes with the hcd to make sure all
  * endpoint state is gone from hardware.  usb_hcd_flush_endpoint() must
  * have been called previously.  Use for set_configuration, set_interface,
diff --git a/drivers/usb/core/hub.c b/drivers/usb/core/hub.c
index 090b3a757112..052dfc14a312 100644
--- a/drivers/usb/core/hub.c
+++ b/drivers/usb/core/hub.c
@@ -5786,7 +5786,7 @@ static void port_event(struct usb_hub *hub, int port1)
 		port_dev->over_current_count++;
 		port_over_current_notify(port_dev);
 
-		dev_dbg(&port_dev->dev, "over-current change #%u\n",
+		dev_notice(&port_dev->dev, "over-current change #%u\n",
 			port_dev->over_current_count);
 		usb_clear_port_feature(hdev, port1,
 				USB_PORT_FEAT_C_OVER_CURRENT);
diff --git a/drivers/usb/core/message.c b/drivers/usb/core/message.c
index 43522f1d6b2b..20d0f1a93586 100644
--- a/drivers/usb/core/message.c
+++ b/drivers/usb/core/message.c
@@ -1325,6 +1325,21 @@ static void remove_intf_ep_devs(struct usb_interface *intf)
 	intf->ep_devs_created = 0;
 }
 
+void usb_fixup_endpoint(struct usb_device *dev, int epaddr, int interval)
+{
+	unsigned int epnum = epaddr & USB_ENDPOINT_NUMBER_MASK;
+	struct usb_host_endpoint *ep;
+
+	if (usb_endpoint_out(epaddr))
+		ep = dev->ep_out[epnum];
+	else
+		ep = dev->ep_in[epnum];
+
+	if (ep && usb_endpoint_xfer_int(&ep->desc))
+		usb_hcd_fixup_endpoint(dev, ep, interval);
+}
+EXPORT_SYMBOL_GPL(usb_fixup_endpoint);
+
 /**
  * usb_disable_endpoint -- Disable an endpoint by address
  * @dev: the device whose endpoint is being disabled
@@ -2238,6 +2253,85 @@ int usb_set_configuration(struct usb_device *dev, int configuration)
 	if (cp->string == NULL &&
 			!(dev->quirks & USB_QUIRK_CONFIG_INTF_STRINGS))
 		cp->string = usb_cache_string(dev, cp->desc.iConfiguration);
+/* Uncomment this define to enable the HS Electrical Test support */
+#define DWC_HS_ELECT_TST 1
+#ifdef DWC_HS_ELECT_TST
+		/* Here we implement the HS Electrical Test support. The
+		 * tester uses a vendor ID of 0x1A0A to indicate we should
+		 * run a special test sequence. The product ID tells us
+		 * which sequence to run. We invoke the test sequence by
+		 * sending a non-standard SetFeature command to our root
+		 * hub port. Our dwc_otg_hcd_hub_control() routine will
+		 * recognize the command and perform the desired test
+		 * sequence.
+		 */
+		if (dev->descriptor.idVendor == 0x1A0A) {
+			/* HSOTG Electrical Test */
+			dev_warn(&dev->dev, "VID from HSOTG Electrical Test Fixture\n");
+
+			if (dev->bus && dev->bus->root_hub) {
+				struct usb_device *hdev = dev->bus->root_hub;
+				dev_warn(&dev->dev, "Got PID 0x%x\n", dev->descriptor.idProduct);
+
+				switch (dev->descriptor.idProduct) {
+				case 0x0101:	/* TEST_SE0_NAK */
+					dev_warn(&dev->dev, "TEST_SE0_NAK\n");
+					usb_control_msg(hdev, usb_sndctrlpipe(hdev, 0),
+							USB_REQ_SET_FEATURE, USB_RT_PORT,
+							USB_PORT_FEAT_TEST, 0x300, NULL, 0, HZ);
+					break;
+
+				case 0x0102:	/* TEST_J */
+					dev_warn(&dev->dev, "TEST_J\n");
+					usb_control_msg(hdev, usb_sndctrlpipe(hdev, 0),
+							USB_REQ_SET_FEATURE, USB_RT_PORT,
+							USB_PORT_FEAT_TEST, 0x100, NULL, 0, HZ);
+					break;
+
+				case 0x0103:	/* TEST_K */
+					dev_warn(&dev->dev, "TEST_K\n");
+					usb_control_msg(hdev, usb_sndctrlpipe(hdev, 0),
+							USB_REQ_SET_FEATURE, USB_RT_PORT,
+							USB_PORT_FEAT_TEST, 0x200, NULL, 0, HZ);
+					break;
+
+				case 0x0104:	/* TEST_PACKET */
+					dev_warn(&dev->dev, "TEST_PACKET\n");
+					usb_control_msg(hdev, usb_sndctrlpipe(hdev, 0),
+							USB_REQ_SET_FEATURE, USB_RT_PORT,
+							USB_PORT_FEAT_TEST, 0x400, NULL, 0, HZ);
+					break;
+
+				case 0x0105:	/* TEST_FORCE_ENABLE */
+					dev_warn(&dev->dev, "TEST_FORCE_ENABLE\n");
+					usb_control_msg(hdev, usb_sndctrlpipe(hdev, 0),
+							USB_REQ_SET_FEATURE, USB_RT_PORT,
+							USB_PORT_FEAT_TEST, 0x500, NULL, 0, HZ);
+					break;
+
+				case 0x0106:	/* HS_HOST_PORT_SUSPEND_RESUME */
+					dev_warn(&dev->dev, "HS_HOST_PORT_SUSPEND_RESUME\n");
+					usb_control_msg(hdev, usb_sndctrlpipe(hdev, 0),
+							USB_REQ_SET_FEATURE, USB_RT_PORT,
+							USB_PORT_FEAT_TEST, 0x600, NULL, 0, 40 * HZ);
+					break;
+
+				case 0x0107:	/* SINGLE_STEP_GET_DEVICE_DESCRIPTOR setup */
+					dev_warn(&dev->dev, "SINGLE_STEP_GET_DEVICE_DESCRIPTOR setup\n");
+					usb_control_msg(hdev, usb_sndctrlpipe(hdev, 0),
+							USB_REQ_SET_FEATURE, USB_RT_PORT,
+							USB_PORT_FEAT_TEST, 0x700, NULL, 0, 40 * HZ);
+					break;
+
+				case 0x0108:	/* SINGLE_STEP_GET_DEVICE_DESCRIPTOR execute */
+					dev_warn(&dev->dev, "SINGLE_STEP_GET_DEVICE_DESCRIPTOR execute\n");
+					usb_control_msg(hdev, usb_sndctrlpipe(hdev, 0),
+							USB_REQ_SET_FEATURE, USB_RT_PORT,
+							USB_PORT_FEAT_TEST, 0x800, NULL, 0, 40 * HZ);
+				}
+			}
+		}
+#endif /* DWC_HS_ELECT_TST */
 
 	/* Now that the interfaces are installed, re-enable LPM. */
 	usb_unlocked_enable_lpm(dev);
